'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _dmx = require('../util/dmx');

var _dmx2 = _interopRequireDefault(_dmx);

var _stateManagement = require('../util/stateManagement');

var _stateManagement2 = _interopRequireDefault(_stateManagement);

var _Universe = require('./Universe');

var _Universe2 = _interopRequireDefault(_Universe);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Root = function () {
  function Root() {
    (0, _classCallCheck3.default)(this, Root);

    this.addUniverse = function (_ref) {
      var name = _ref.name,
          _ref$mode = _ref.mode,
          mode = _ref$mode === undefined ? "null" : _ref$mode,
          port = _ref.port,
          children = _ref.children;

      var universe = _dmx2.default.addUniverse(name, mode, port);
      console.log("Added Universe:", name);
      _stateManagement2.default.universes.push({
        name: name,
        children: children.map(function (c) {
          return Object.assign({}, c.props);
        })
      });
    };
  }

  (0, _createClass3.default)(Root, [{
    key: 'appendChild',
    value: function appendChild(child) {
      if (child instanceof _Universe2.default) {
        var _child$props = child.props,
            _child$props$name = _child$props.name,
            name = _child$props$name === undefined ? "default-universe" : _child$props$name,
            _child$props$mode = _child$props.mode,
            mode = _child$props$mode === undefined ? "null" : _child$props$mode,
            port = _child$props.port;

        this.addUniverse({ name: name, mode: mode, port: port, children: child.children });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      return _stateManagement2.default.universes;
    }
  }]);
  return Root;
}();

exports.default = Root;