'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createElement = undefined;

var _Root = require('../components/Root');

var _Root2 = _interopRequireDefault(_Root);

var _Universe = require('../components/Universe');

var _Universe2 = _interopRequireDefault(_Universe);

var _Light = require('../components/Light');

var _Light2 = _interopRequireDefault(_Light);

var _stateManagement = require('../util/stateManagement');

var _stateManagement2 = _interopRequireDefault(_stateManagement);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function createElement(type) {
  var props = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

  var COMPONENTS = {
    ROOT: function ROOT() {
      return new _Root2.default();
    },
    light: function light() {
      return new _Light2.default(_stateManagement2.default.universes.length > 0 ? _stateManagement2.default.universes[0].name : null, props);
    },
    universe: function universe() {
      return new _Universe2.default(null, props);
    },
    default: undefined
  };

  return COMPONENTS[type]() || COMPONENTS.default;
}

exports.createElement = createElement;