"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require("babel-runtime/regenerator");

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require("babel-runtime/helpers/asyncToGenerator");

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var render = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(element) {
    var container, node, output;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            // Create root container instance
            container = (0, _createElement.createElement)("ROOT");

            // Returns the current fiber (flushed fiber)

            node = _reconciler2.default.createContainer(container);

            // Schedules a top level update with current fiber and a priority level (depending upon the context)

            _reconciler2.default.updateContainer(element, node, null);

            // Parse the input component and return the output
            output = (0, _parse2.default)(container);
            _context.next = 6;
            return new Promise(function (resolve, reject) {
              // Update the DMX universes
              try {
                output.forEach(function (u) {
                  _dmx2.default.update(u.name, u.channels);
                });resolve();
              } catch (err) {
                reject(err);
              }
            });

          case 6:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function render(_x) {
    return _ref.apply(this, arguments);
  };
}();

var _reconciler = require("./reconciler");

var _reconciler2 = _interopRequireDefault(_reconciler);

var _parse = require("./parse");

var _parse2 = _interopRequireDefault(_parse);

var _createElement = require("./createElement");

var _dmx = require("../util/dmx");

var _dmx2 = _interopRequireDefault(_dmx);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = render;