"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = diffProperties;
function diffProperties(type, lastProps, nextProps) {
  var updatePayload = null;

  var lastPropsKeys = Object.keys(lastProps);

  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = lastPropsKeys[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var propKey = _step.value;

      if (nextProps.hasOwnProperty(propKey) || !lastProps.hasOwnProperty(propKey) || lastProps[propKey] === null) {
        continue;
      }

      if (updatePayload === null) {
        updatePayload = [];
      }

      // all removed props will be null
      updatePayload.push(propKey, null);
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator.return) {
        _iterator.return();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }

  var nextPropsKeys = Object.keys(nextProps);

  var hasLastProps = lastProps !== null;

  var _iteratorNormalCompletion2 = true;
  var _didIteratorError2 = false;
  var _iteratorError2 = undefined;

  try {
    for (var _iterator2 = nextPropsKeys[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
      var _propKey = _step2.value;

      var nextProp = nextProps[_propKey];
      var lastProp = hasLastProps ? lastProps[_propKey] : undefined;
      if (!nextProps.hasOwnProperty(_propKey) || nextProp === lastProp || !nextProp && !lastProp) {
        continue;
      }

      if (_propKey === "children") {
        if (lastProp !== nextProp && (typeof nextProp === "string" || typeof nextProp === "number")) {
          // update text

          if (updatePayload === null) {
            updatePayload = [];
          }

          updatePayload.push(_propKey, "" + nextProp);
        }
      } else {
        // update value

        if (updatePayload === null) {
          updatePayload = [];
        }

        updatePayload.push(_propKey, nextProp);
      }
    }
  } catch (err) {
    _didIteratorError2 = true;
    _iteratorError2 = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion2 && _iterator2.return) {
        _iterator2.return();
      }
    } finally {
      if (_didIteratorError2) {
        throw _iteratorError2;
      }
    }
  }

  return updatePayload;
}