'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _universeChannels = require('./universeChannels');

var _universeChannels2 = _interopRequireDefault(_universeChannels);

var _dmx = require('./dmx');

var _dmx2 = _interopRequireDefault(_dmx);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* Since React-DMX doesn't have a DOM to compare the
   virtual DOM against, there needs to be some kind
   of State Management. That's what this file is for
 */
var State = function State() {
  var _this = this;

  (0, _classCallCheck3.default)(this, State);

  this.triggerDMXUpdate = function () {
    var channels = (0, _universeChannels2.default)(_this.universes);
    channels.forEach(function (u) {
      _dmx2.default.update(u.name, u.channels);
    });
    setTimeout(_this.triggerDMXUpdate, 23);
  };

  this.updateUniverse = function (universe, _ref) {
    var channel = _ref.channel,
        intensity = _ref.intensity;

    var updatedUniverses = _this.universes.map(function (u) {
      if (u.name === universe) {
        u.children = u.children.map(function (c) {
          if (c.channel === channel) {
            return { channel: channel, intensity: intensity };
          }
          return c;
        });
      }
      return u;
    });
    _this.universes = updatedUniverses;
  };

  this.universes = [];
  this.triggerDMXUpdate();
};

exports.default = new State();